#include "DistrhoPlugin.hpp"
#include <tuple>
#include <array>

class Resonator
{
public:
    Resonator():
    xp(0), xpp(0), yp(0), ypp(0), app(0), ap(0), scale(1){};

    inline float process(float x);
    void clear();
    void set(double _app, double _ap, double _scale);

private:
    float xp;
    float xpp;
    float yp;
    float ypp;
    double app;
    double ap;
    double scale;
};

class Filter
{
public:
    Filter();
    void process(float **outputs, const float **inputs, uint32_t frames);
    void set(double x, double y, double p);

private:
    std::array<std::array<Resonator, 2>, 2> res;
};